#property copyright "Luca Giuranna"
#property link      ""

#import "MetaScalper.dll"
  void WakeUp(string symbol);
	double GetAbsoluteTarget3();
	double GetAbsoluteTarget2();
	double GetAbsoluteTarget1();
	double GetAbsoluteStop();
  int GetTarget3();
	int GetTarget2();
	int GetTarget1();
	int GetStop();
	int GetAdjustLots();
	int GetOpenLots();
	bool IsStopActive();
	bool IsTarget1Active();
	bool IsTarget2Active();
	bool IsTarget3Active();
	double GetLotSize();
	int GetEvent();
#import

#include <stderror.mqh>
#include <stdlib.mqh>

static int eventBuy =									1;
static int eventSell =								2;
static int eventAdd =									3;
static int eventReduce =							4;
static int eventCloseAll =						5;
static int eventSetStop =					    6;
static int eventUnsetStop =				    7;
static int eventUpdateStop =				  8;
static int eventSetTarget1 =				  12;
static int eventUnsetTarget1 =		  	13;
static int eventSetTarget2 =			 	  14;
static int eventUnsetTarget2 =			  15;
static int eventSetTarget3 =				  16;
static int eventUnsetTarget3 =			  17;
static int eventUpdateTarget1 =			  18;
static int eventUpdateTarget2 =			  19;
static int eventUpdateTarget3 =			  20;

static int MODE_FLAT = 0;
static int MODE_LONG = 1;
static int MODE_SHORT = -1;

int magicNumber = 12345678;
int event;
int currentMode = 0;
double currentStop = 0;

//
// Main loop
//
int start() {
  WakeUp(Symbol());
  ObjectCreate("SpreadDisplay", OBJ_LABEL, 0, 0, 0);
  ObjectSet("SpreadDisplay", OBJPROP_XDISTANCE, 3);
  ObjectSet("SpreadDisplay", OBJPROP_YDISTANCE, 10);
   
  while(true) {
    RefreshRates();
    updateDisplay();
    //if (IsBreakEvenActive()) setBreakEven();
    //Comment("IsBreakEvenActive(): ", IsBreakEvenActive());
    //setBreakEven();
    event = GetEvent();
    //if (event > 0) Alert(event);
    if (event == eventBuy) {
      buy();
      if (IsStopActive()) setStop();
      setTargets();
    }
    else if (event == eventSell) {
      sell();
      if (IsStopActive()) setStop();
      setTargets();
    }
    else if (event == eventAdd) {
      add();
      if (IsStopActive()) setStop(true);
      setTargets(true);
    }
    else if (event == eventReduce) {
      reduce();
    }
    else if (event == eventCloseAll) {
      closeAll();
    }
    else if (event == eventSetStop || event == eventUnsetStop || event == eventUpdateStop) {
      setStop();
    }
    else if (event == eventSetTarget1 || event == eventUnsetTarget1 || event == eventUpdateTarget1) {
      setTarget1();
    }
    else if (event == eventSetTarget2 || event == eventUnsetTarget2 || event == eventUpdateTarget2) {
      setTarget2();
    }
    else if (event == eventSetTarget3 || event == eventUnsetTarget3 || event == eventUpdateTarget3) {
      setTarget3();
    }
    Sleep(1);
  }
  return(0);
}

//
// Open position (BUY)
//
void buy() {
  if (OrdersTotal() > 0) {
    showError("Position already open");
    return;
  }
  int lotsToOpen = GetOpenLots();
  double lotSize = GetLotSize();
  for (int i = 1; i <= lotsToOpen; i++) {
    int ticket = OrderSend(Symbol(), OP_BUY, lotSize, Ask, 0, 0, 0, "Enter Long", magicNumber, 0, Green);
    if (ticket >= 1) {
      currentMode = MODE_LONG;
    }
  }  
}

//
// Open position (SELL)
//
void sell() {
  if (OrdersTotal() > 0) {
    showError("Position already open");
    return;
  }
  int lotsToOpen = GetOpenLots();
  double lotSize = GetLotSize();
  for (int i = 1; i <= lotsToOpen; i++) {
    int ticket = OrderSend(Symbol(), OP_SELL, lotSize, Bid, 0, 0, 0, "Enter Short", magicNumber, 0, Red);
    if (ticket >= 1) {
      currentMode = MODE_SHORT;
    }
  }  
}

//
// Add to position
//
void add() {
  if (OrdersTotal() == 0) {
    showError("No positions to add to");
    return;
  }
  int lotsToOpen = GetAdjustLots();
  double lotSize = GetLotSize();
  if (currentMode == MODE_LONG) {
    for (int i = 1; i <= lotsToOpen; i++) {
      if (!OrderSend(Symbol(), OP_BUY, lotSize, Ask, 0, 0, 0, "Add To Long", magicNumber, 0, Green)) {
        if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
      }
    }
  }
  else if (currentMode == MODE_SHORT) {
    for (i = 1; i <= lotsToOpen; i++) {
      if (!OrderSend(Symbol(), OP_SELL, lotSize, Bid, 0, 0, 0, "Add To Short", magicNumber, 0, Red)) {
        if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
      }
    }
  }
}

//
// Reduce position
//
void reduce() {
  if (OrdersTotal() == 0) {
    showError("No positions to reduce");
    return;
  }
  int closed = 0;
  int lotsToClose = GetAdjustLots();
  double lotSize = GetLotSize();
  for (int i = OrdersTotal() - 1; i >= 0; i--) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      if (!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue)) {
        if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
      }
      closed++;
    }
    if (closed >= lotsToClose) {
      break;
    }
  }
  if (OrdersTotal() <= 0) {
    currentMode = MODE_FLAT;
  }
}

//
// Close all position
//
void closeAll() {
  if (OrdersTotal() == 0) {
    return;
  }
  bool closeError = false;
  for (int i = OrdersTotal() - 1; i >= 0; i--) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      if (!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue)) {
        closeError = true;
      }
    }
  }
  if (!closeError) {
    currentMode = MODE_FLAT;
  }
}

//
// Set stop
//
void setStop(bool adding = false) {
  if (OrdersTotal() == 0 || currentMode == MODE_FLAT) {
    return;
  }
  double stopPrice = NormalizeDouble(0, Digits);
  double stopAbsolutePrice = NormalizeDouble(GetAbsoluteStop(), Digits);
  if (adding) {
    stopPrice = currentStop;
  }
  else {
    if (IsStopActive()) {
      if (stopAbsolutePrice > 0) {
        stopPrice = stopAbsolutePrice;
      }
      else {
        if (currentMode == MODE_LONG) {
          stopPrice = NormalizeDouble(Bid - (getPips(GetStop()) * Point), Digits);
        }
        else if (currentMode == MODE_SHORT) {
          stopPrice = NormalizeDouble(Ask + (getPips(GetStop()) * Point), Digits);
        }
      }
    }
  }
  currentStop = stopPrice;
  for (int i = 0; i < OrdersTotal(); i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      if (stopPrice != OrderStopLoss()) {
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), stopPrice, OrderTakeProfit(), 0, Blue)) {
          if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
        }
      }
    }
  }
}

//
// Set target 1
//
void setTarget1(bool adding = false) {
  if (OrdersTotal() == 0 || currentMode == MODE_FLAT) {
    return;
  }
  double target = NormalizeDouble(0, Digits);
  double targetAbsolutePrice = NormalizeDouble(GetAbsoluteTarget1(), Digits);
  for (int i = 0; i < OrdersTotal(); i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      if (IsTarget1Active()) {
        if (targetAbsolutePrice > 0) {
          target = targetAbsolutePrice;
        }
        else {
          if (currentMode == MODE_LONG) {
            target = NormalizeDouble(OrderOpenPrice() + (getPips(GetTarget1()) * Point), Digits);
          }
          else if (currentMode == MODE_SHORT) {
            target = NormalizeDouble(OrderOpenPrice() - (getPips(GetTarget1()) * Point), Digits);
          }
        }
      }
      if (target != OrderTakeProfit()) {
        if (adding && OrderTakeProfit() > 0) continue;
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), target, 0, Orange)) {
          if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
        }
      }
      break;
    }
  }
}

//
// Set target 2
//
void setTarget2(bool adding = false) {
  if (OrdersTotal() == 0 || currentMode == MODE_FLAT) {
    return;
  }
  double target = NormalizeDouble(0, Digits);
  double targetAbsolutePrice = NormalizeDouble(GetAbsoluteTarget2(), Digits);
  int toSkip = 1;
  int skipped = 0;
  for (int i = 0; i < OrdersTotal(); i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      skipped++;
      if (skipped <= toSkip) {
        continue;
      }
      if (IsTarget2Active()) {
        if (targetAbsolutePrice > 0) {
          target = targetAbsolutePrice;
        }
        else {
          if (currentMode == MODE_LONG) {
            target = NormalizeDouble(OrderOpenPrice() + (getPips(GetTarget2()) * Point), Digits);
          }
          else if (currentMode == MODE_SHORT) {
            target = NormalizeDouble(OrderOpenPrice() - (getPips(GetTarget2()) * Point), Digits);
          }
        }
      }
      if (target != OrderTakeProfit()) {
        if (adding && OrderTakeProfit() > 0) continue;
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), target, 0, Orange)) {
          if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
        }
      }
      break;
    }
  }
}

//
// Set target 3
//
void setTarget3(bool adding = false) {
  if (OrdersTotal() == 0 || currentMode == MODE_FLAT) {
    return;
  }
  double target = NormalizeDouble(0, Digits);
  double targetAbsolutePrice = NormalizeDouble(GetAbsoluteTarget3(), Digits);
  int toSkip = 2;
  int skipped = 0;
  for (int i = 0; i < OrdersTotal(); i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderMagicNumber() == magicNumber) {
      skipped++;
      if (skipped <= toSkip) {
        continue;
      }
      if (IsTarget3Active()) {
        if (targetAbsolutePrice > 0) {
          target = targetAbsolutePrice;
        }
        else {
          if (currentMode == MODE_LONG) {
            target = NormalizeDouble(OrderOpenPrice() + (getPips(GetTarget3()) * Point), Digits);
          }
          else if (currentMode == MODE_SHORT) {
            target = NormalizeDouble(OrderOpenPrice() - (getPips(GetTarget3()) * Point), Digits);
          }
        }
      }
      if (target != OrderTakeProfit()) {
        if (adding && OrderTakeProfit() > 0) continue;
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), target, 0, Orange)) {
          if (GetLastError() != 0) showError(ErrorDescription(GetLastError()));
        }
      }
      break;
    }
  }
}

//
// Set target 1, 2, 3
//
void setTargets(bool adding = false) {
  if (IsTarget1Active()) setTarget1(adding);
  if (IsTarget2Active()) setTarget2(adding);
  if (IsTarget3Active()) setTarget3(adding);
}

//
// Get a correct pips number
//
int getPips(int pips) {
  if (Digits == 5 || Digits == 3) {
    return (pips * 10);
  }
  return (pips);
}

//
// Update chart display
//
void updateDisplay() {
  ObjectSetText("SpreadDisplay", DoubleToStr((Ask - Bid)*10000, 1), 18, "Arial", Lime);
}

//
// Display an error
//
void showError(string text) {
  PlaySound("alert2.wav");
  MessageBox(text);
}



